﻿SuperStrict
rem
	Xeres@BlitzForum.de - MiniBCC #9
	Build as: Command line program (Console)
endrem
AppTitle = "Cut&Sort"
?Debug
	Print("Args: " + AppArgs.length)
?
Local imgcount:Int = 0
For Local cmd:String = EachIn AppArgs
	?Debug
    	Print("#" + cmd + "#")
	?
  	Local pix:TPixmap = LoadPixmap(cmd)
	If pix = Null Then Continue
	imgcount:+1
	Print("Bild ~q" + StripDir(cmd) + "~q (" + imgcount + ")")
	Print("Gib die Hintergrundfarbe ein, Standard (leere Eingabe) ist = ~q255,0,255~q")
	Local in:String
	?Debug
		in = ""
	?Not Debug
		in = Input("|> ")
	?
	Local color:String[] = ["255", "0", "255"]
	If in And in.Contains(",") Then
		Local c:String[] = in.Split(",")
		If(c.Length >= 3) Then color = c
	EndIf
	Local r:Int = color[0].ToInt()
	Local g:Int = color[1].ToInt()
	Local b:Int = color[2].ToInt()
	Local argb_bg:Int = $FF000000 + r * $10000 + g * $100 + b
	
	Rem
		Ränder abschneiden, ein Bild finden, wiederholen
	endrem
	
	pix = CutImageBorder(argb_bg, pix)
	While Not(ImageIsEmpty(argb_bg, pix))
	
		Timg.Create(GetSubPixmap(argb_bg, pix))
		pix = CutImageBorder(argb_bg, pix)
		
	Wend
	
	rem
		Den ganzen Mist Sortieren
	EndRem
	Timg.sort()
	?Debug
		Local i:Int = 0
		For Local p:Timg = EachIn Timg.list
			SavePixmapPNG(p.p, StripAll(cmd) + "_sub_" + i + ".png", 9)
			i:+1
		Next
	?
	
	Local h:Int = Timg(Timg.list.First()).h
	Local w:Int	'* Maximale Breite suchen...
	For Local p:Timg = EachIn Timg.list
		w:+p.w + 1
	Next
	
	Local FinalPix:TPixmap = CreatePixmap(w, h, PF_RGBA8888)
	FinalPix.ClearPixels(argb_bg)
	
	Local xpos:Int = 0, ypos:Int = 0
	Local lastH:Int = 0, lastW:Int = 0
	While Not(Timg.IsEmpty())
		Local i:Timg = Timg.Get()
		
		rem
			Jetzt müsste man noch Teile finden, die
			unter das letze ding passen... aber ich habe keine Zeit mehr.
		endrem
		
		rem
		If lastH + i.h + 1 < h And lastW < i.w Then
			ypos = lastH + 1
			xpos = lastW
		Else
			ypos = 0
			xpos:+i.w + 1
		EndIf
		endrem
		
		FinalPix.Paste(i.p, xpos, ypos)
		lastW = i.w
		lastH = i.h
		xpos:+i.w + 1
	Wend
	
	'* Überschuss nochmal abschneiden...
	FinalPix = CutImageBorder(argb_bg, FinalPix)
	SavePixmapPNG(FinalPix, StripAll(cmd) + "_result.png", 9)
	
	
Next

?Debug
	Print("-Ende-")
	Input("->")
?
End

Function GetSubPixmap:TPixmap(_argb:Int, pix:TPixmap)
	?Debug
    	Print("GetSubPixmap()")
	?
	Rem
		finde ein rechteck, das nicht _argb enthält
		schneide das rechteck aus, fülle die fläche mit _argb
		gibt den ausschnitt zurück
	endrem
	
	'* Finde startposition:
	Local startX:Int = -1, startY:Int = 0
	For Local x:Int = 0 Until pix.width
		If (_argb <> pix.ReadPixel(x, 0)) Then
			startX = x
			Exit
		EndIf	
	Next
	
	'* Verfolge Pixel um max/min koordinaten zu finden:
	Local sx:Int = -1, sy:Int = -1, ex:Int = -1, ey:Int = -1
	TPos.Create(startX, startY)
	Local p:TPos
	Local isDone:Int[,] = New Int[pix.width, pix.height]
	Local dX:Int[] = [1, 0, -1, 0]
	Local dY:Int[] = [0, 1, 0, -1]
	
	While Not(TPos.IsEmpty())
		p = TPos.Get()
		
	
		For Local i:Int = 0 Until 4
			Local x:Int = p.x + dX[i]
			Local y:Int = p.y + dY[i]
			If InPixMap(x, y, pix) Then
				If Not(isDone[x, y]) Then
					If pix.ReadPixel(x, y) <> _argb Then
						TPos.Create(x, y)
						If sx = -1 Or x < sx Then sx = x
						If sy = -1 Or y < sy Then sy = y
						If ex = -1 Or x > ex Then ex = x
						If ey = -1 Or y > ey Then ey = y
					EndIf
					isDone[x, y] = True
				EndIf
			EndIf
		Next

	Wend
	TPos.Clear()
	Print("sx: " + sx + ", sy: " + sy + ", ex: " + ex + ", ey: " + ey)
	
	'* Ausschnitt erstellen
	Local w:Int = ex - sx + 1
	Local h:Int = ey - sy + 1
	Local result:TPixmap = pix.Copy().Window(sx, sy, w, h)
	
	'* Ausschnitt ausmalen:
	For Local y:Int = sy To ey
		For Local x:Int = sx To ex
			pix.WritePixel(x, y, _argb)
		Next
	Next
	
	'* Ergebnis
	Return result
	
	Function InPixMap:Int(_x:Int, _y:Int, pix:TPixmap)
		If _x < 0 Then Return False
		If _y < 0 Then Return False
		If _x > pix.width - 1 Then Return False
		If _y > pix.height - 1 Then Return False
		Return True
	EndFunction
		
End Function

Function ImageIsEmpty:Int(_argb:Int, pix:TPixmap)
	?Debug
		Print("img size: " + (pix.width * pix.height))
	?
	For Local y:Int = 0 Until pix.height
		For Local x:Int = 0 Until pix.width
			If (_argb <> pix.ReadPixel(x, y)) Then
				Return False
			EndIf	
		Next
	Next
	Return True
End Function

Function CutImageBorder:TPixmap(_argb:Int, pix:TPixmap)
	?Debug
    	Print("CutImageBorder()")
	?
	Local topY:Int = 0
	For Local y:Int = 0 Until pix.height
		For Local x:Int = 0 Until pix.width
			If (_argb = pix.ReadPixel(x, y)) Then
			 	topY = y
			Else
				y = pix.height
				Exit
			EndIf	
		Next
	Next
	
	Local bottomY:Int = 0
	For Local y:Int = pix.height - 1 Until 0 Step - 1
		For Local x:Int = 0 Until pix.width
			If (_argb = pix.ReadPixel(x, y)) Then
			 	bottomY = (pix.height - 1) - y
			Else
				y = 0
				Exit
			EndIf
		Next
	Next
	
	Local leftX:Int = 0
	For Local x:Int = 0 Until pix.width
		For Local y:Int = 0 Until pix.height
			If (_argb = pix.ReadPixel(x, y)) Then
			 	leftX = x
			Else
				x = pix.width
				Exit
			EndIf	
		Next
	Next
	
	
	Local rightX:Int = 0
	For Local x:Int = pix.width - 1 Until 0 Step - 1
		For Local y:Int = 0 Until pix.height
			If (_argb = pix.ReadPixel(x, y)) Then
			 	rightX = (pix.width - 1) - x
			Else
				x = 0
				Exit
			EndIf	
		Next
	Next
	
	'* Schneide Ränder Ab:
	Local w:Int = pix.width - rightX - leftX
	Local h:Int = pix.height - bottomY - topY
	If w > 0 And h > 0 Then
		Return pix.Window(leftX, topY, w, h)
	Else
		Return pix
	EndIf
	
EndFunction

Type TPos
	Field x:Int, y:Int
	Global list:TList = New TList
	
	Method New()
		list.AddLast(Self)
	End Method
	
	Function Clear()
		TPos.list.Clear()
	End Function
	
	Function IsEmpty:Int()
		Return TPos.list.IsEmpty()
	End Function
	
	Function Get:TPos()
		Return TPos(TPos.list.RemoveFirst())
	End Function
	
	Function Create:TPos(_x:Int, _y:Int)
		Local p:TPos = New TPos
		p.x = _x
		p.y = _y
		Return p
	End Function
End Type

Type Timg
	Field p:TPixmap, w:Int, h:Int
	Global list:TList = New TList
	
	Method New()
		list.AddLast(Self)
	End Method

	Function Create:Timg(_p:TPixmap)
		Local i:Timg = New Timg
		i.p = _p
		i.w = _p.width
		i.h = _p.height
		Return i
	End Function
	
	Function sort()
		Timg.list.sort(False, Timg.DoCompare)
	End Function
	
	Function IsEmpty:Int()
		Return Timg.list.IsEmpty()
	End Function
	
	Function Get:Timg()
		Return Timg(Timg.list.RemoveFirst())
	End Function
	
	Function DoCompare:Int(o1:Object, o2:Object)
		Rem
			implementiert die Sortierung
			1. Höhe
			2. Breite
			3. Fläche
		endrem
		Local i1:Timg = Timg(o1)
		Local i2:Timg = Timg(o2)
		
		Return i1.h - i2.h
		'Return ((i1.h - i2.h) * 2) + ((i1.w - i2.w) * 3) + (((i1.w * i1.h) - (i2.w * i2.h)) * 4)
		
	End Function
	
End Type